/***************************************************************************
                          sensor.c  -  description
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/* FILE NOT USED ANYMORE */

#include <k8000.h>
#include <sys/time.h>
#include <sys/io.h>
#include <stdio.h>
#include <unistd.h>

int InitBoard(short lptport,short delay)
{
	if(ioperm(0x378, 3, 1))
	{
		printf("Error getting port permission\n");
		return 1;
	}
		
	SelectI2CprinterPort(lptport);
	I2CbusDelay = delay;
	ConfigIOchannelAsInput(16);
	return 0;
}


int ReadDirectPulseLength(int io_channel,int pulscount)
{

	int pulsefound=0;
	int tot_length=0;
	int cur_length=0;
	int maximum=0,minimum=9999999;
	int flag_up=0;
	int tmp=1;

	struct timeval strt_time,stp_time;

	while(pulscount>pulsefound)
	{
		ReadIOchannel(io_channel);
		/* if we have an event */
		if(tmp==0&&IO[io_channel]==1) /* change upwards */
		{
			/* register uptime */
			gettimeofday(&strt_time,NULL);
			flag_up = 1;				
		}
		else if (tmp==1&&IO[io_channel]==0&&flag_up) /*change downwards */
		{
			gettimeofday(&stp_time,NULL);
			if (strt_time.tv_usec > stp_time.tv_usec)
			{	
				stp_time.tv_usec += 1000000;
				stp_time.tv_sec--;
			}
			cur_length = (stp_time.tv_usec-strt_time.tv_usec);
			tot_length = tot_length+cur_length;
			
			/* verify max an min values */
			if(minimum>cur_length)
				minimum = cur_length;
			if(maximum<cur_length)
				maximum = cur_length;
				
			/*printf("  Totaal UP in Usec = %ld\n",(stp_time.tv_usec-strt_time.tv_usec));*/
			pulsefound++;
			flag_up = 0;
		}
		tmp = IO[io_channel];
	}
	/* calculate average length (after stripping of the max an min */
	return ( (tot_length-minimum-maximum)/(pulsefound-2));
}
