##########################################
# Script to start the rt_sensor.o module #
##########################################

#!/bin/sh

# Remove old module
rmmod rt_tempd

# remove the RealTimeLinux modules
rmmod rtl_fifo
rmmod rtl_posixio
rmmod rtl_sched
rmmod rtl_time

# Install the RealTimeLinux modules
insmod rtl_time
insmod rtl_sched
insmod rtl_posixio
insmod rtl_fifo

# Sync disks to be sure
sync

# Install the rt_sensor module
insmod rt_tempd.o